#ifndef MEMPIN_H
#define MEMPIN_H

#include "BasePin.h"

class MemInputPin : public InputPin, public IMemInputPin {
public:
	MemInputPin();
	~MemInputPin();

	void Deactivate();

	ULONG STDMETHODCALLTYPE AddRef();
	ULONG STDMETHODCALLTYPE Release();
	HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppvObject);

	HRESULT STDMETHODCALLTYPE GetAllocator(IMemAllocator **ppAllocator);
	HRESULT STDMETHODCALLTYPE NotifyAllocator(IMemAllocator *pAllocator, BOOL bReadOnly);
	HRESULT STDMETHODCALLTYPE GetAllocatorRequirements(ALLOCATOR_PROPERTIES *pProps);
	HRESULT STDMETHODCALLTYPE Receive(IMediaSample *pSample);

	HRESULT STDMETHODCALLTYPE ReceiveMultiple(IMediaSample **pSamples, long nSamples, long *nSamplesProcessed);
	HRESULT STDMETHODCALLTYPE ReceiveCanBlock();

protected:
	IMemAllocator *mpAllocator;
};

class MemOutputPin : public OutputPin {
public:
	MemOutputPin();
	~MemOutputPin();

	HRESULT STDMETHODCALLTYPE Disconnect();
	HRESULT STDMETHODCALLTYPE Connect(IPin *pReceivePin, const AM_MEDIA_TYPE *pmt);

protected:
	IMemAllocator *mpAllocator;
	IMemInputPin *mpTransportPin;
};

#endif
