#ifndef UTILS_H
#define UTILS_H

class MediaTypePtr {
public:
	MediaTypePtr();
	MediaTypePtr(const AM_MEDIA_TYPE *);
	MediaTypePtr(const MediaTypePtr& src);
	~MediaTypePtr();

	MediaTypePtr& operator=(const AM_MEDIA_TYPE *);
	MediaTypePtr& operator=(const MediaTypePtr& p);

	operator AM_MEDIA_TYPE *() { return mpMediaType; }
	operator const AM_MEDIA_TYPE *() const { return mpMediaType; }

	AM_MEDIA_TYPE *operator->() { return mpMediaType; }
	const AM_MEDIA_TYPE *operator->() const { return mpMediaType; }

	void Attach(AM_MEDIA_TYPE *);
	AM_MEDIA_TYPE *Detach();

protected:
	AM_MEDIA_TYPE	*mpMediaType;
};

class Lock {
public:
	Lock();
	Lock(const Lock&);
	~Lock();

	Lock& operator=(const Lock&) { return *this; }

	void Enter();
	void Exit();

protected:
	CRITICAL_SECTION	mCsect;
};

bool DSAreMediaTypesEqual(const AM_MEDIA_TYPE *p, const AM_MEDIA_TYPE *q);
bool DSAddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister);
void DSRemoveFromRot(DWORD pdwRegister);

#endif
